﻿/**
Textualizer v2.5.0

Dual licensed under the MIT or GPL Version 2 licenses.

Copyright (c) 2011 Kirollos Risk

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
(function($,window){"use strict";var Textualizer,COMMON_CHARACTER_ARRANGE_DELAY=1000,REMAINING_CHARACTERS_DELAY=500,EFFECT_DURATION=2000,REMAINING_CHARACTERS_APPEARANCE_MAX_DELAY=2000,REMOVE_CHARACTERS_MAX_DELAY=2000;function getStyle(element){var computedStyle,key,camelCasedStyle,i,len,styleList={};if(window.getComputedStyle){computedStyle=window.getComputedStyle(element,null);if(computedStyle.length){for(i=0,len=computedStyle.length;i<len;i++){camelCasedStyle=computedStyle[i].replace(/\-([a-z])/,function(a,b){return b.toUpperCase()});styleList[camelCasedStyle]=computedStyle.getPropertyValue(computedStyle[i])}}else{for(key in computedStyle){if(typeof computedStyle[key]!=='function'&&key!=='length'){styleList[key]=computedStyle[key]}}}}else{computedStyle=element.currentStyle||element.style;for(key in computedStyle){if(Object.prototype.hasOwnProperty.call(computedStyle,key)){styleList[key]=computedStyle[key]}}}
return styleList}
function Character(){this.character=null;this.domNode=null;this.pos=null;this.used=!1;this.inserted=!1;this.visited=!1}
function Snippet(){this.str='';this.characterList=[]}
Snippet.prototype={use:function(val){var ch=null;$.each(this.characterList,function(){if(this.character===val&&!this.used){this.used=!0;ch=this;return!1}});return ch},reset:function(){$.each(this.characterList,function(){this.inserted=!1;this.used=!1})}};Textualizer=function($element,data,options){var self=this,list=[],snippets,index,previous,showCharEffect=null,playing=!1,paused=!1,elementHeight,position,$clone,$container,$phantomContainer;if(options.effect!=='random'){$.each($.fn.textualizer.effects,function(){if(this[0]===options.effect){showCharEffect=this[1];return!1}})}
$clone=$element.clone().removeAttr('id').appendTo(window.document.body);$clone.css(getStyle($element[0]));$clone.css({position:'absolute',top:'-1000px'});$phantomContainer=$('<div />').css({'position':'relative','visibility':'hidden'}).appendTo($clone);$element.css('overflow','hidden');$container=$('<div />').css('position','relative').appendTo($element);elementHeight=$element.height();position={bottom:elementHeight};function positionSnippet(snippet,phantomSnippets){var yOffset=options.centered?(elementHeight-$phantomContainer.height())/2:0;$.each(phantomSnippets,function(index,c){c.pos=c.domNode.position();c.domNode=c.domNode.clone();c.pos.top+=yOffset;c.domNode.css({'left':c.pos.left,'top':c.pos.top,'position':'absolute'});snippet.characterList.push(c)});$phantomContainer.html('')}
function addCharsToSnippet(i){var phantomSnippets=[],snippet=new Snippet(),j,ch,c,len;snippet.str=list[i];snippets.push(snippet);for(j=0,len=snippet.str.length;j<len;j++){ch=snippet.str.charAt(j);if(ch===''){$phantomContainer.append(' ')}else{c=new Character();c.character=ch;c.domNode=$('<span/>').text(ch);$phantomContainer.append(c.domNode);phantomSnippets.push(c)}}
positionSnippet(snippet,phantomSnippets);return snippet}
function getHideEffect(){var dfd,eff;eff=[function(target){dfd=$.Deferred();target.animate({top:position.bottom,opacity:'hide'},dfd.resolve);return dfd.promise()},function(target){dfd=$.Deferred();target.fadeOut(1000,dfd.resolve);return dfd.promise()}];return eff[Math.floor(Math.random()*eff.length)]}
function removeCharacters(previousSnippet,currentSnippet){var keepList=[],removeList=[],finalDfd=$.Deferred(),hideEffect=getHideEffect(),currChar;$.each(previousSnippet.characterList,function(index,prevChar){currChar=currentSnippet.use(prevChar.character);if(currChar){currChar.domNode=prevChar.domNode;currChar.inserted=!0;keepList.push(currChar)}else{(function hideCharacter(deferred){removeList.push(deferred);hideEffect(prevChar.domNode.delay(Math.random()*REMOVE_CHARACTERS_MAX_DELAY)).done(function(){prevChar.domNode.remove();deferred.resolve()})})($.Deferred())}});$.when.apply(null,removeList).done(function(){return finalDfd.resolve(keepList)});return finalDfd.promise()}
function showCharacters(snippet){var effects=$.fn.textualizer.effects,effect=options.effect==='random'?effects[Math.floor(Math.random()*(effects.length-2))+1][1]:showCharEffect,finalDfd=$.Deferred(),animationDfdList=[];$.each(snippet.characterList,function(index,ch){if(!ch.inserted){ch.domNode.css({'left':ch.pos.left,'top':ch.pos.top});(function animateCharacter(deferred){window.setTimeout(function(){effect({item:ch,container:$container,dfd:deferred})},Math.random()*REMAINING_CHARACTERS_APPEARANCE_MAX_DELAY);animationDfdList.push(deferred)})($.Deferred())}});$.when.apply(null,animationDfdList).done(function(){finalDfd.resolve()});return finalDfd.promise()}
function moveAndShowRemainingCharacters(characters,currentSnippet){var finalDfd=$.Deferred(),rearrangeDfdList=[];window.setTimeout(function(){$.each(characters,function(index,item){(function rearrangeCharacters(deferred){item.domNode.animate({'left':item.pos.left,'top':item.pos.top},options.rearrangeDuration,deferred.resolve);rearrangeDfdList.push(deferred.promise())})($.Deferred())});$.when.apply(null,rearrangeDfdList).done(function(){window.setTimeout(function(){showCharacters(currentSnippet).done(function(){finalDfd.resolve()})},REMAINING_CHARACTERS_DELAY)})},COMMON_CHARACTER_ARRANGE_DELAY);return finalDfd.promise()}
function rotater(){if(index===list.length-1){$.each(snippets,function(j,snippet){snippet.reset()});index=-1;if(!options.loop){self.pause()}}
index++;next(index)}
function rotate(i){var dfd=$.Deferred(),current=snippets[i];if(!current){current=addCharsToSnippet(i)}
if(previous){removeCharacters(previous,current).done(function(characters){moveAndShowRemainingCharacters(characters,current).done(function(){dfd.resolve()})})}else{showCharacters(current).done(function(){dfd.resolve()})}
previous=current;return dfd.promise()}
function next(i){if(paused){return}
rotate(i).done(function(){$element.trigger('textualzer.blurbchanged',{index:i});window.setTimeout(rotater,options.duration)})}
this.data=function(dataSource){this.stop();list=dataSource;snippets=[]};this.stop=function(){this.pause();playing=!1;previous=null;index=0;$container.empty();$phantomContainer.empty()};this.pause=function(){paused=!0;playing=!1};this.start=function(){if(list.length===0||playing){return}
index=index||0;playing=!0;paused=!1;next(index)};this.destroy=function(){$container.parent().removeData('textualizer').end().remove();$phantomContainer.remove()};if(data&&data instanceof Array){this.data(data)}};$.fn.textualizer=function(/*args*/){var args=arguments,snippets,options,instance,txtlzr;txtlzr=(function($element){instance=$element.data('textualizer');if(!instance){snippets=[];if(args.length===1&&args[0]instanceof Array){snippets=args[0]}else if(args.length===1&&typeof args[0]==='object'){options=args[0]}else if(args.length===2){snippets=args[0];options=args[1]}
if(snippets.length===0){$element.find('p').each(function(){snippets.push($(this).text())})}
$element.html("");instance=new Textualizer($element,snippets,$.extend({},$.fn.textualizer.defaults,options));$element.data('textualizer',instance)}
return instance})(this);if(typeof args[0]==='string'&&txtlzr[args[0]]){txtlzr[args[0]].apply(txtlzr,Array.prototype.slice.call(args,1))}
return this};$.fn.textualizer.defaults={effect:'random',duration:2000,rearrangeDuration:1000,centered:!1,loop:!0};$.fn.textualizer.effects=[['none',function(obj){obj.container.append(obj.item.domNode.show())}],['fadeIn',function(obj){obj.container.append(obj.item.domNode.fadeIn(EFFECT_DURATION,obj.dfd.resolve));return obj.dfd.promise()}],['slideLeft',function(obj){obj.item.domNode.appendTo(obj.container).css({'left':-1000}).show().animate({'left':obj.item.pos.left},EFFECT_DURATION,obj.dfd.resolve);return obj.dfd.promise()}],['slideTop',function(obj){obj.item.domNode.appendTo(obj.container).css({'top':-1000}).show().animate({'top':obj.item.pos.top},EFFECT_DURATION,obj.dfd.resolve);return obj.dfd.promise()}]]})(jQuery,window)